<template>
  <div>
    <div
      id="modal_subasta_eliminar"
      class="modal fade"
      tabindex="-1"
      aria-hidden="true"
    >
      <div class="modal-dialog mw-650px">
        <div
          id="modal_subasta_eliminar_formulario"
          class="modal-content rounded"
        >
          <div class="modal-header">
            <h3 class="modal-title">
              ¿Estás seguro?
            </h3>

            <div
              id="modal_subasta_eliminar_btn_cerrar"
              class="btn btn-icon btn-sm btn-active-light-primary ms-2"
              data-bs-dismiss="modal"
              aria-label="Close"
            >
              <i class="bi bi-x-lg" />
            </div>
          </div>

          <div class="modal-body scroll-y">
            <p class="fs-3">
              Ha seleccionado eliminar la subasta: <span class="fs-3 fw-bolder">{{ subasta.titulo }}</span>, con identififcador: <span class="fs-3 fw-bolder">{{ subasta.id }}</span>
            </p>
            <p class="fs-3">
              Una vez eliminado, ¡no podrá recuperar esta información!
            </p>
          </div>

          <div class="modal-footer px-10 py-5">
            <button
              type="button"
              class="btn btn-secondary"
              data-bs-dismiss="modal"
            >
              Cancelar
            </button>
            <button
              id="modal_subasta_eliminar_btn_eliminar"
              type="button"
              class="btn btn-danger"
              @click="onSubastaEliminar()"
            >
              <span class="indicator-label">Eliminar</span>
              <span class="indicator-progress">
                Espere por favor... <span class="spinner-border spinner-border-sm align-middle ms-2" />
              </span>
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import BloqueoUI from "@/core/util/BloqueoUI";
import Servicio from "@/core/servicio/Servicio";
import Ruta from "@/core/servicio/Ruta";
import Toast from "@/core/util/Toast";

export default {
  name: 'ModalSubastaEliminar',
  components: {
  },
  props: {
    subasta: { type: Object, required: true, default() {
        return {
          id: {type: Number, required: true},
          titulo: {type: String, required: true}
        }
      }
    }
  },
  emits: ['onSubastaListar'],
  data() {
    return {
      componentes: {
        bloqueoUI: null,
      }
    };
  },

  mounted() {
    this.componentes.bloqueoUI = new BloqueoUI('#modal_subasta_eliminar_formulario', '#modal_subasta_eliminar_btn_eliminar');
  },

  methods: {
    onSubastaEliminar() {
      this.componentes.bloqueoUI.iniciarBloqueoFormulario();
      Servicio.delete(Ruta.rutaPanelSubastaEliminar(this.subasta.id)).then( (data) => {
        Toast.mostrarExito(data.mensaje);
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        this.$emit('onSubastaListar');
        this.cerrarModal();
      }).catch((error) => {
        this.componentes.bloqueoUI.terminarBloqueoFormulario();
        Toast.mostrarError(error);
      });
    },

    cerrarModal() {
      document.querySelector('#modal_subasta_eliminar_btn_cerrar').click();
    }
  },

}
</script>